#include <windows.h>
#include <shellapi.h>

#include "main.h"

extern int PistaActual;

NOTIFYICONDATA TrayIcon;

HWND 	BPlay;
HWND 	BStop;
HWND 	BPause;
HWND 	BPrev;
HWND 	BNext;
HWND 	BEject;
HWND 	Display;
HWND 	BList;
HWND	BLoop;
HWND 	TrayIconIMG;
HWND	hwndPList;
HWND 	TrackBar;
HWND	Logo;

void Update_Tray_Icon(HWND hwnd, int icono);
HWND WINAPI CreateTrackbar(HWND hwnd, UINT iMin, UINT iMax);


void CrearGui()
{
	HBITMAP oxlogo;

	BPrev =	CreateWindow("BUTTON", "", WS_VISIBLE |WS_CHILD | BS_BITMAP, 3, 50, 30, 25, hwndMain, (HMENU)IDC_PREV, hInst, 0);
	BStop =	CreateWindow("BUTTON", "",  WS_VISIBLE|WS_CHILD | BS_BITMAP, 34, 50, 30,25, hwndMain, (HMENU)IDC_STOP,hInst, 0);
	BPause = CreateWindow("BUTTON", "",WS_VISIBLE |WS_CHILD | BS_BITMAP, 65, 50, 30, 25, hwndMain, (HMENU)IDC_PAUSE,hInst, 0);
	BPlay =	CreateWindow("BUTTON", "", WS_VISIBLE |WS_CHILD | BS_BITMAP, 96, 50, 30, 25, hwndMain, (HMENU)IDC_PLAY,hInst, 0);
	BNext =	CreateWindow("BUTTON", "", WS_VISIBLE |WS_CHILD | BS_BITMAP, 127, 50, 30, 25, hwndMain, (HMENU)IDC_NEXT,hInst, 0);
	BEject = CreateWindow("BUTTON", "",WS_VISIBLE | WS_CHILD | BS_BITMAP, 160, 50, 30, 25, hwndMain, (HMENU)IDC_EJECT,hInst, 0);


	SendMessage(BPrev,	BM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)LoadBitmap(hInst, MAKEINTRESOURCE(BMP_PREV)));
	SendMessage(BStop,	BM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)LoadBitmap(hInst, MAKEINTRESOURCE(BMP_STOP)));
	SendMessage(BPause,	BM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)LoadBitmap(hInst, MAKEINTRESOURCE(BMP_PAUSE)));
	SendMessage(BPlay,	BM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)LoadBitmap(hInst, MAKEINTRESOURCE(BMP_PLAY)));
	SendMessage(BNext,	BM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)LoadBitmap(hInst, MAKEINTRESOURCE(BMP_NEXT)));
	SendMessage(BEject,	BM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)LoadBitmap(hInst, MAKEINTRESOURCE(BMP_EJECT)));


	Display = CreateWindow("STATIC", "",WS_BORDER | WS_VISIBLE | WS_CHILD | SS_CENTER, 5, 5, 100, 25, hwndMain, 0, hInst, 0 );
	BList = CreateWindow ("BUTTON", "",  WS_VISIBLE | WS_CHILD | BS_FLAT| BS_BITMAP, 115, 5, 25 , 12 , hwndMain, (HMENU)IDC_PL,hInst, 0);
	BLoop = CreateWindow ("BUTTON", "", WS_VISIBLE | WS_CHILD | BS_FLAT| BS_BITMAP, 115, 18, 25 , 12 , hwndMain, (HMENU)IDC_LOOP,hInst, 0);


	Logo = CreateWindow	("STATIC", "",  WS_VISIBLE | WS_CHILD | SS_ICON | SS_NOTIFY, 150, 5, 35, 25, hwndMain, 0, hInst, 0 );

	SendMessage(Display, WM_SETFONT, (WPARAM) "TIMES", (LPARAM) MAKELPARAM(1, 0));
	SendMessage(BList,	BM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)LoadBitmap(hInst, MAKEINTRESOURCE(BMP_PL_OFF)));
	SendMessage(BLoop,	BM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)LoadBitmap(hInst, MAKEINTRESOURCE(BMP_LOOP_OFF)));
	SendMessage(Logo,	STM_SETIMAGE, (WPARAM)IMAGE_ICON, (LPARAM)LoadIcon(hInst, MAKEINTRESOURCE(OX_LOGO)));
	hwndPList = CreateDialog(hInst,MAKEINTRESOURCE(DLG_PLIST),hwndMain,PlayListProc);

	TrackBar = CreateTrackbar(hwndMain, 0, 0);

}

void CrearTrayIcon(HWND hwnd, HINSTANCE hInst)
{

	TrayIcon.cbSize = sizeof(TrayIcon);

	TrayIconIMG =(HICON)LoadImage(hInst, MAKEINTRESOURCE(ICO_STOP),	IMAGE_ICON, 16, 16, LR_DEFAULTCOLOR);


	TrayIcon.hIcon = TrayIconIMG;
	TrayIcon.hWnd = hwnd;

	strcpy(TrayIcon.szTip,"CD Player");

	TrayIcon.uCallbackMessage = WM_TRAYICON;
	TrayIcon.uFlags = NIF_ICON | NIF_MESSAGE | NIF_TIP;
	TrayIcon.uID = (UINT)hInst;

	Shell_NotifyIcon(NIM_ADD, &TrayIcon);



}

void Update_Tray_Icon(HWND hwnd, int icono)
{



	TrayIconIMG =(HICON)LoadImage(hInst, MAKEINTRESOURCE(icono),	IMAGE_ICON, 16, 16, LR_DEFAULTCOLOR);

	TrayIcon.hIcon = TrayIconIMG;

	Shell_NotifyIcon(NIM_MODIFY, &TrayIcon);


}

void BorrarTrayIcon()
{
	Shell_NotifyIcon(NIM_DELETE, &TrayIcon);

}


HWND WINAPI CreateTrackbar(HWND hwnd, UINT iMin, UINT iMax)
{

	HWND hwndTrack;

	hwndTrack = CreateWindowEx(
		0,                             // no extended styles
		TRACKBAR_CLASS,                // class name
		"Trackbar Control",            // title (caption)
		WS_CHILD | WS_VISIBLE |
		    TBS_NOTICKS ,
		1, 30,                        // position
		190, 20,                       // size
		hwnd,                       // parent window
		(HMENU)NULL,             // control identifier
		hInst,                       // instance
		NULL                           // no WM_CREATE parameter
		);

	SendMessage(hwndTrack, TBM_SETPOS,(WPARAM) TRUE,(LPARAM) 0);

	return hwndTrack;
}

void ClearDisplay()
{
	char TrackNum[20];
	ActualPos=0;
	ActualMin=0;
	ActualSec=0;
	wsprintf(TrackNum, "%i  0:00", PistaActual);
	SendMessage(Display, WM_SETTEXT, 0, (LPARAM) TrackNum);
}

