#include <windows.h>
#include <mmsystem.h>

#include "main.h"

#define NoCd 1001
#define NoAudioCd 1002

BOOL Loop = 0;
BOOL Reentr = 0;
BOOL Repetir = 0;
BOOL CDInit = 0;
BOOL Tocando = 0;
BOOL EnPause = 0;
BOOL EsCdMusical = 0;
BOOL BandejaAbierta = 0;
int PistaActual = 0;
int MaxPistas = 25;
int TamanoPista = 0;
int ActualPos = 0;
int ActualMin = 0;
int ActualSec = 0;
int PauseMin = 0;
int PauseSec = 0;
unsigned int UnidadCD;
UINT IDDispositivo;



BOOL InitCD(void);
int RevisarUnidad(int DriveDeAudio);
int GetCdInfo();
void PlayTrack(int min, int sec);
void CleanTheMess();
void CDStop();
void CDPause(BOOL state);
void IniciarElCD();
unsigned int GetTrackLength();
/*************************/



void CD_Command(int action, int min, int sec)
{

	char TrackNum[10];

	switch(action)
	{


	case PLAY:

		if(CDInit==0)
		{

			InitCD();
			if(!EsCdMusical)
			{
				CleanTheMess();
				ClearDisplay();
				SendMessage(BPlay,	WM_KILLFOCUS, 0,0);
				break;
			}
			GetCdInfo();
		}

		if(Tocando)
		{
			if (TrackMove)
			{
				PlayTrack(min, sec);
			}
			else{
				ActualPos = 0;
				SendMessage(TrackBar, TBM_SETPOS, (WPARAM) TRUE , (LPARAM)ActualPos);
				ClearDisplay();
				PlayTrack(0, 0);
			}

			SendMessage(BPlay,	WM_KILLFOCUS, 0,0);
			break;
		}

		Update_Tray_Icon(hwndMain,ICO_PLAY);
		Tocando=1;
		ClearDisplay();
		PlayTrack(0, 0);

		SendMessage(BPlay,	WM_KILLFOCUS, 0,0);
		break;


	case STOP:

		if(Tocando)
		{

			CDStop();


		}
		SendMessage(BStop,	WM_KILLFOCUS, 0,0);
		ActualPos = 0;
		SendMessage(TrackBar, TBM_SETPOS, (WPARAM) TRUE , (LPARAM)ActualPos);
		Update_Tray_Icon(hwndMain,ICO_STOP);
		break;

	case NEXT:


		PistaActual+=1;


		if(!Tocando)
		{
			ClearDisplay();

		}
		else{
			ActualPos = 0;
			SendMessage(TrackBar, TBM_SETPOS, (WPARAM) TRUE , (LPARAM)ActualPos);
			ClearDisplay();
			PlayTrack(0, 0);
		}

		SendMessage(BNext,	WM_KILLFOCUS, 0,0);

		break;

	case PREV:

		if(PistaActual==1)
		{
			Reentr=1;
			if(Loop)
			{
				PistaActual+=MaxPistas-1;
				Reentr=0;
			}
		}
		else{
			PistaActual-=1;
			Reentr=0;
		}

		if(!Tocando)
		{
			ClearDisplay();

		}
		else{

			if(!Reentr)
				ActualPos = 0;

			SendMessage(TrackBar, TBM_SETPOS, (WPARAM) TRUE , (LPARAM)ActualPos);
			ClearDisplay();
			PlayTrack(0, 0);

		}

		SendMessage(BPrev,	WM_KILLFOCUS, 0,0);
		break;
	case PAUSE:

		if (!Tocando)
		{
			return;
		}

		if (!EnPause)
		{
			CDPause(1);
			SendMessage(BPause,	WM_KILLFOCUS, 0,0);
			Update_Tray_Icon(hwndMain,ICO_PAUSE);
		}
		else
		    {
			CDPause(0);
			SendMessage(BPause,	WM_KILLFOCUS, 0,0);
			Update_Tray_Icon(hwndMain,ICO_PLAY);
		}
		break;

	case EJECT:
		if(BandejaAbierta==0)
		{


			if (Tocando)
			{
				CDStop();
				Tocando = 0;
			}

			if(CDInit==0)
			{
				InitCD();
			}

			Update_Tray_Icon(hwndMain,ICO_EJECT);
			mciSendCommand(IDDispositivo, MCI_SET, MCI_SET_DOOR_OPEN, (DWORD)0);
			CleanTheMess();
			BandejaAbierta=1;
			SendMessage(BEject,	WM_KILLFOCUS, 0,0);
			ClearDisplay();
			ActualPos = 0;
			SendMessage(TrackBar, TBM_SETPOS, (WPARAM) TRUE , (LPARAM)ActualPos);
			break;
		}
		else{


			if(CDInit==0)
			{
				InitCD();
			}

			mciSendCommand(IDDispositivo, MCI_SET, MCI_SET_DOOR_CLOSED, (DWORD)0);
			BandejaAbierta=0;

			CleanTheMess();

			SendMessage(BEject,	WM_KILLFOCUS, 0,0);
			Update_Tray_Icon(hwndMain,ICO_STOP);
			break;

		}

	}

}


void MciCallBack(HWND hwnd, WPARAM wParam,LPARAM lParam)
{
	switch(wParam)
	{
	case MCI_NOTIFY_SUCCESSFUL:
		if(Tocando)
		{
			if(Loop)
			{
				PistaActual+=1;
				ActualPos = 0;
				SendMessage(TrackBar, TBM_SETPOS, (WPARAM) TRUE , (LPARAM)ActualPos);
				ClearDisplay();
				PlayTrack(0, 0);
				break;
			}
			CDStop();
		}


		break;

	}

}

BOOL InitCD(void)
{

	MCI_OPEN_PARMS	InitParams;
	MCI_SET_PARMS	ConfigParams;

	DWORD Retorno = 0;
	int Contador;
	char InitDisp[3];
	char MensajeDeError[255];
	char DriveDeAudio[255];

	for (unsigned int Drive= 'D'; Drive <= 'K'; Drive++)
	{
		char DriveAct[4];
		wsprintf(DriveAct, "%c:\\", Drive);
		if (GetDriveType(DriveAct) == DRIVE_CDROM)
		{

			UnidadCD=Drive;

		}

	}


	wsprintf(InitDisp,"%c:", (char)UnidadCD);
	InitParams.lpstrDeviceType = (LPCSTR) MCI_DEVTYPE_CD_AUDIO;
	InitParams.lpstrElementName = InitDisp;

	if(Retorno = mciSendCommand(0, MCI_OPEN, MCI_OPEN_TYPE | MCI_OPEN_SHAREABLE | MCI_OPEN_TYPE_ID | MCI_OPEN_ELEMENT, (DWORD) (LPVOID) &InitParams))
	{
		mciGetErrorString(Retorno, MensajeDeError, 255);
		MessageBox(0, MensajeDeError, "Error", 0);

		return 1;
	}

	IDDispositivo = InitParams.wDeviceID;

	ConfigParams.dwTimeFormat = MCI_FORMAT_TMSF;

	if (Retorno = mciSendCommand(IDDispositivo, MCI_SET, MCI_SET_TIME_FORMAT, (DWORD)(LPVOID) &ConfigParams))
	{
		mciGetErrorString(Retorno, MensajeDeError, 255);
		mciSendCommand(IDDispositivo, MCI_CLOSE, 0, (DWORD)0);
		MessageBox(0, MensajeDeError, "Error", 0);

		return 1;
	}


	Retorno = RevisarUnidad(UnidadCD);
	switch(Retorno)
	{
	case NoCd:

		return 1;

	case NoAudioCd:

		return 1;
	}

	GetCdInfo();
	UpdatePlayList();
	CDInit=1;
	return 0;
}


int RevisarUnidad(int DriveDeAudio)
{

	char MensajeDeError[255];
	int ErrorCode;
	DWORD Retorno;
	MCI_STATUS_PARMS	EstadoDeCD;

	EstadoDeCD.dwItem = MCI_CDA_STATUS_TYPE_TRACK;
	EstadoDeCD.dwTrack = 1;

	if(Retorno = mciSendCommand(IDDispositivo, MCI_STATUS, MCI_STATUS_ITEM | MCI_TRACK | MCI_WAIT, (DWORD) (LPVOID) &EstadoDeCD))
	{

		return NoCd;
	}


	if (EstadoDeCD.dwReturn != MCI_CDA_TRACK_AUDIO)
	{
		return NoAudioCd;
	}

	return 0;
}



int GetCdInfo()
{

	DWORD	Retorno;
	MCI_STATUS_PARMS	CdStatus;
	char MensajeDeError[255];
	EsCdMusical = 0;

	MaxPistas = 0;

	CdStatus.dwItem = MCI_STATUS_READY;


	if (Retorno = mciSendCommand(IDDispositivo, MCI_STATUS, MCI_STATUS_ITEM | MCI_WAIT, (DWORD) (LPVOID) &CdStatus))
	{

		mciGetErrorString(Retorno, MensajeDeError, 255);
		MessageBox(0, MensajeDeError,"We have a problem here", 0);
		return -1;
	}

	CdStatus.dwItem = MCI_STATUS_NUMBER_OF_TRACKS;

	if (Retorno = mciSendCommand(IDDispositivo, MCI_STATUS, MCI_STATUS_ITEM | MCI_WAIT, (DWORD) (LPVOID) &CdStatus))
	{

		mciGetErrorString(Retorno, MensajeDeError, 255);
		MessageBox(0, MensajeDeError, "We have a problem here", 0);
		return -1;
	}

	EsCdMusical = 1;
	MaxPistas = CdStatus.dwReturn;

	return 0;

}

unsigned int GetTrackLength()
{

	/*
	MCI_STATUS_PARMS CdStatusParams;
	MCI_SET_PARMS	CdSetParams;


	CdSetParams.dwTimeFormat = MCI_FORMAT_MILLISECONDS;
	mciSendCommand (IDDispositivo, MCI_SET, MCI_SET_TIME_FORMAT, (DWORD) (LPVOID) &CdSetParams);

	CdStatusParams.dwItem = MCI_STATUS_LENGTH;
	CdStatusParams.dwTrack = PistaActual;
	mciSendCommand(IDDispositivo, MCI_STATUS, MCI_STATUS_ITEM | MCI_TRACK | MCI_WAIT, (DWORD) (LPVOID) &CdStatusParams);

	TamanoPista = CdStatusParams.dwReturn/=1000;
	ActualMin = CdStatusParams.dwReturn/60;
	ActualSec = CdStatusParams.dwReturn%60;

	CdSetParams.dwTimeFormat = MCI_FORMAT_TMSF;
	mciSendCommand (IDDispositivo, MCI_SET, MCI_SET_TIME_FORMAT, (DWORD) (LPVOID) &CdSetParams);

	SendMessage(TrackBar, TBM_SETRANGE,(WPARAM) (BOOL) TRUE,
	(LPARAM) MAKELONG(0, TamanoPista));

	return CdStatusParams.dwReturn;
	*/
	return 0;
}
void PlayTrack(int min, int sec)
{
	DWORD Retorno;
	char TrackNum[10];
	MCI_STATUS_PARMS CdStatusParams;
	MCI_PLAY_PARMS CdPlayParams;
	MCI_SET_PARMS	CdSetParams;

	KillTimer(hwndMain, IDC_TIMER);

	if(PistaActual==0)
	{
		PistaActual = 1;
	}

	if(PistaActual==(MaxPistas+1))
	{
		PistaActual=1;
	}


	SetTimer(hwndMain,IDC_TIMER, 1000, (TIMERPROC) NULL);

	CdSetParams.dwTimeFormat = MCI_FORMAT_MILLISECONDS;
	mciSendCommand (IDDispositivo, MCI_SET, MCI_SET_TIME_FORMAT, (DWORD) (LPVOID) &CdSetParams);

	CdStatusParams.dwItem = MCI_STATUS_LENGTH;
	CdStatusParams.dwTrack = PistaActual;
	mciSendCommand(IDDispositivo, MCI_STATUS, MCI_STATUS_ITEM | MCI_TRACK | MCI_WAIT, (DWORD) (LPVOID) &CdStatusParams);

	TamanoPista = CdStatusParams.dwReturn/=1000;

	SendMessage(TrackBar, TBM_SETRANGE,(WPARAM) (BOOL) TRUE,
		(LPARAM) MAKELONG(0, TamanoPista));

	CdSetParams.dwTimeFormat = MCI_FORMAT_TMSF;
	mciSendCommand (IDDispositivo, MCI_SET, MCI_SET_TIME_FORMAT, (DWORD) (LPVOID) &CdSetParams);


	CdStatusParams.dwItem = MCI_STATUS_LENGTH;
	CdStatusParams.dwTrack = PistaActual;
	mciSendCommand(IDDispositivo, MCI_STATUS, MCI_STATUS_ITEM | MCI_TRACK | MCI_WAIT, (DWORD) (LPVOID) &CdStatusParams);

	TamanoPista = CdStatusParams.dwReturn;


	CdPlayParams.dwFrom = MCI_MAKE_TMSF(PistaActual, ActualMin, ActualSec,0);
	CdPlayParams.dwTo = (CdStatusParams.dwReturn << 8) | PistaActual;
	CdPlayParams.dwCallback = (DWORD)hwndMain;
	mciSendCommand(IDDispositivo, MCI_PLAY, MCI_NOTIFY | MCI_FROM | MCI_TO, (DWORD)(LPVOID) &CdPlayParams);


	SendMessage(TrackList,LB_SETCURSEL, (WPARAM)PistaActual-1, 0);

	Tocando=1;
	TrackMove=0;
	SetFocus(TrackBar);
}


void CleanTheMess()
{

	CDStop();
	mciSendCommand(IDDispositivo, MCI_CLOSE, MCI_WAIT, (DWORD)NULL);


	Reentr = 0;
	Repetir = 0;
	CDInit = 0;
	Tocando = 0;
	EnPause = 0;
	EsCdMusical = 0;
	BandejaAbierta = 0;
	PistaActual = 0;
	TamanoPista = 0;
	IDDispositivo = 0;
	ActualMin = 0;
	ActualPos = 0;
	TrackMove = 0;
	ClearTrackList();
}


void CDStop()
{

	mciSendCommand(IDDispositivo, MCI_PAUSE, 0, 0);
	KillTimer(hwndMain, IDC_TIMER);
	ClearDisplay();
	Tocando = 0;

}
void CDPause(BOOL state)
{
	MCI_GENERIC_PARMS	CdGenerico;
	if(state)
	{
		KillTimer(hwndMain, IDC_TIMER);
		CdGenerico.dwCallback = (DWORD)hwndMain;
		mciSendCommand(IDDispositivo, MCI_PAUSE, 0, (DWORD)(LPVOID) &CdGenerico);
		PauseMin = ActualPos / 60;
		PauseSec = ActualPos % 60;
		TrackMove = 1;
	}
	else
	    {
		CD_Command(PLAY, PauseMin, PauseSec);
	}

}
